<script setup lang="ts">
import { defineProps, defineEmits } from "vue";
import { useUsers } from "../stores/useUsers";
import { XMarkIcon } from "@heroicons/vue/24/outline";
import type { TUser } from "../types/user.type";

const props = defineProps<
  | {
      open: true;
      user: TUser;
    }
  | {
      open: false;
      user: null;
    }
>();

const emits = defineEmits<{
  save: [user: TUser];
  close: [];
}>();

const store = useUsers();

function handleClickDelete() {
  if (!props.open) return;
  store.deleteUser(props.user.id);
  emits("close");
}

function handleClickCancel() {
  emits("close");
}
</script>

<template>
  <div class="fixed inset-0 z-30 bg-black/20">
    <div class="relative flex h-full w-full items-center justify-center">
      <dialog
        :open="props.open"
        class="w-[500px] rounded-lg border bg-white focus:outline-sky-400/50"
      >
        <div class="mb-2 flex items-center justify-between p-4">
          <div class="text-xl font-semibold">Delete User</div>
          <button
            class="rounded-full p-1 hover:bg-gray-200 focus:outline-none"
            @click="emits('close')"
          >
            <XMarkIcon class="h-5 w-5" />
          </button>
        </div>
        <div class="p-4">
          <div class="mb-8 p-2 text-center">
            <p>
              Are you sure want to delete user <b>{{ props.user?.name }}</b
              >?
            </p>
          </div>
          <div class="flex items-center justify-between gap-4">
            <button
              class="w-full rounded-md border border-sky-600 px-4 py-2 text-sm font-bold text-sky-600 hover:bg-sky-100 focus:outline-none"
              @click="handleClickCancel"
            >
              Cancel</button
            ><button
              class="w-full rounded-md bg-red-600 px-4 py-2 text-sm font-bold text-white hover:bg-red-700 focus:outline-none"
              @click="handleClickDelete"
            >
              Delete
            </button>
          </div>
        </div>
      </dialog>
    </div>
  </div>
</template>
